#! /bin/sh
#
# $Id: build.sh,v 1.14 2010/05/06 05:06:27 juli Exp $

# Build.
build_host() {
	host="$1"

	debug Build Host Build $host

	check_host $host

	. $BOM_HOSTCONFDIR/$host
	info Begin Host Build $host
	build_kernel $kernel
	build_world $world
	info End Host Build $host
}

build_kernel() {
	kernel="$1"

	debug Build Kernel Build $kernel

	check_kernel $kernel

	. $BOM_KERNELCONFDIR/$kernel
	info Begin Kernel Build $kernel
	export KERNCONF MODULES_OVERRIDE TARGET TARGET_ABI TARGET_ARCH TARGET_CPUTYPE
	export __MAKE_CONF=/dev/null

	export MAKEOBJDIRPREFIX=$BOM_KERNELOBJDIR/$kernel
	_build_objdir_create $MAKEOBJDIRPREFIX

	state kernel $kernel new
	cd ${BOM_SRCDIR} && saveexit make ${BOM_MAKEFLAGS} kernel-toolchain | logoutput kernel $kernel create
	if checkexit; then
		# XXX Good 1/2?
	else
		state kernel $kernel bad
		error "Could not build kernel toolchain."
	fi
	cd ${BOM_SRCDIR} && saveexit make ${BOM_MAKEFLAGS} buildkernel | logoutput kernel $kernel append
	if checkexit; then
		state kernel $kernel good
	else
		state kernel $kernel bad
		error "Could not build kernel."
	fi
	info End Kernel Build $kernel
}

build_world() {
	world="$1"

	debug Build World Build $world

	check_world $world

	. $BOM_WORLDCONFDIR/$world
	info Begin World Build $world
	export TARGET TARGET_ABI TARGET_ARCH TARGET_CPUTYPE
	export __MAKE_CONF=/dev/null

	export MAKEOBJDIRPREFIX=$BOM_WORLDOBJDIR/$world
	_build_objdir_create $MAKEOBJDIRPREFIX

	worldflags=""
	for _with in ${with}; do
		_with_option=WITH_`echo ${_with} | tr a-z A-Z`=1
		worldflags="${worldflags} ${_with_option}"
	done
	for _without in ${without}; do
		_without_option=WITHOUT_`echo ${_without} | tr a-z A-Z`=1
		worldflags="${worldflags} ${_without_option}"
	done

	state world $world new
	cd ${BOM_SRCDIR} && saveexit make ${BOM_MAKEFLAGS} ${worldflags} buildworld | logoutput world $world create
	if checkexit; then
		state world $world good
	else
		state world $world bad
		error "Could not build world."
	fi
	info End World Build $world
}

_build_objdir_create() {
	objdir="$1"

	if [ -d $objdir ]; then
		rm -rf $objdir
	fi

	mkdir -p $objdir
}
