#! /bin/sh
#
# $Id: deploy.sh,v 1.7 2010/05/06 05:06:27 juli Exp $

# Deploying.
deploy_host() {
	host="$1"
	shift

	check_host $host

	. $BOM_HOSTCONFDIR/$host

	if [ ! -e $BOM_HOSTDEPLOYDIR/$host ]; then
		mkdir -p $BOM_HOSTDEPLOYDIR/$host
	fi

	state host $host new
	if ! _deploy_world $world $host; then
		state host $host bad
		return
	fi
	if ! _deploy_kernel $kernel $host; then
		state host $host bad
		return
	fi
	state host $host good
}

_deploy_kernel() {
	kernel="$1"
	shift

	host="$1"
	shift

	check_kernel $kernel

	. $BOM_KERNELCONFDIR/$kernel
	export KERNCONF MODULES_OVERRIDE TARGET TARGET_ABI TARGET_ARCH TARGET_CPUTYPE
	export MAKEOBJDIRPREFIX=$BOM_KERNELOBJDIR/$kernel
	export DESTDIR=$BOM_HOSTDEPLOYDIR/$host
	export __MAKE_CONF=/dev/null

	cd ${BOM_SRCDIR} && saveexit sudo -E make ${BOM_MAKEFLAGS} installkernel | logoutput host $host append
	if checkexit; then
		return 0
	else
		info "Could not deploy kernel."
		return 1
	fi
}

_deploy_world() {
	world="$1"
	shift

	host="$1"
	shift

	check_world $world

	. $BOM_WORLDCONFDIR/$world
	export TARGET TARGET_ABI TARGET_ARCH TARGET_CPUTYPE
	export MAKEOBJDIRPREFIX=$BOM_WORLDOBJDIR/$world
	export DESTDIR=$BOM_HOSTDEPLOYDIR/$host
	export __MAKE_CONF=/dev/null

	worldflags=""
	for _with in ${with}; do
		_with_option=WITH_`echo ${_with} | tr a-z A-Z`=1
		worldflags="${worldflags} ${_with_option}"
	done
	for _without in ${without}; do
		_without_option=WITHOUT_`echo ${_without} | tr a-z A-Z`=1
		worldflags="${worldflags} ${_without_option}"
	done

	cd ${BOM_SRCDIR} && saveexit sudo -E make ${BOM_MAKEFLAGS} ${worldflags} installworld | logoutput host $host create
	if checkexit; then
	else
		info "Could not deploy world."
		return 1
	fi
	cd ${BOM_SRCDIR} && saveexit sudo -E make ${BOM_MAKEFLAGS} ${worldflags} distribution | logoutput host $host append
	if checkexit; then
		return 0
	else
		info "Could not deploy distribution."
		return 1
	fi
}
