#! /bin/sh
#
# $Id: status.sh,v 1.4 2010/05/03 23:16:48 juli Exp $

# Status.
status_host() {
	host="$1"

	debug Status Host $host

	check_host $host

	. $BOM_HOSTCONFDIR/$host
	info Begin Host $host
	status_kernel $kernel
	status_world $world
	info End Host $host
}

status_kernel() {
	kernel="$1"

	debug Status Kernel $kernel

	check_kernel $kernel

	. $BOM_KERNELCONFDIR/$kernel
	info Begin Kernel $kernel
	statefile=`statefile kernel $kernel`
	if [ ! -e $statefile ]; then
		warning "Missing state file."
	else
		tail -1 $statefile
	fi
	info End Kernel $kernel
}

status_world() {
	world="$1"

	debug Status World $world

	check_world $world

	. $BOM_WORLDCONFDIR/$world
	info Begin World $world
	statefile=`statefile world $world`
	if [ ! -e $statefile ]; then
		warning "Missing state file."
	else
		tail -1 $statefile
	fi
	info End World $world
}
