#! /bin/sh
#
# $Id: util.sh,v 1.10 2010/05/06 00:33:10 juli Exp $

# Utilities.
date_tag() {
	date +%s
}

# Exit status.
saveexit() {
	"$@"
	echo $? > $BOM_TMPDIR/exit
}

checkexit() {
	return `cat $BOM_TMPDIR/exit`
}

# Log messaging.
debug() {
	if [ ! -z "$BOM_DEBUG" ]; then
		log DEBUG "$@"
	fi
}

error() {
	log ERROR "$@"
	exit 1
}

info() {
	log INFO "$@"
}

warning() {
	log WARNING "$@"
}

log() {
	level="$1"
	shift

	date_tag | xargs -I__DATE__ /bin/echo "__DATE__ [bom/"${level}"]" "$@" > /dev/stderr
}

# Log files.
logoutput() {
	kind="$1"
	shift

	tag="$1"
	shift

	mode="$1"
	shift

	file=`logfile $kind $tag`

	case $mode in
	create)
		[ ! -e $file ] || rm $file || error "Could not unlink logfile."
		;;
	append)
		;;
	*)
		error "Unknown logfile mode."
	esac

	dir=`dirname $file`
	[ -d $dir ] || mkdir -p $dir
	cat >> $file 2>&1
}

logfile() {
	kind="$1"
	shift

	tag="$1"
	shift

	logdir=""
	case $kind in
	host)
		logdir=$BOM_HOSTLOGDIR
		;;
	kernel)
		logdir=$BOM_KERNELLOGDIR
		;;
	world)
		logdir=$BOM_WORLDLOGDIR
		;;
	esac

	echo $logdir/$tag
}
